<!DOCTYPE html>
<html>

<head>
    <!-- Vue map implementation with leaflet library-->
    <!-- https://travishorn.com/interactive-maps-with-vue-leaflet-5430527353c8 -->

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>app4food</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
    <link rel="stylesheet" type="text/css" href="./style.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>

    <!-- access to database via REST-->
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue"></script>

    <!--maps support-->
    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.2.0/dist/leaflet.css">

    <!-- SVILUPPO-->
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.12/dist/vue.js"></script>
    <!--PRODUZIONE -->
    <!-- <script src="https://cdn.jsdelivr.net/npm/vue@2.6.12"></script> -->
    <script src="https://unpkg.com/leaflet@1.2.0/dist/leaflet.js"></script>

    <!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.18.0/axios.js"></script> -->
    <!-- <script src="https://unpkg.com/vue"></script>  -->

    <!-- <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script> -->
    <!-- <script src="./myvue.js"></script>  -->

</head>

<body>
    <!-- Carusel con una slide -->
    <div id="carouselExampleSlidesOnly" class="carousel slide" data-ride="carousel">
        <div class="carousel-inner">
        <div class="carousel-item active">
            <img class="d-block w-100" src="./img/a4f_banner_400.jpg" alt="banner">
        </div>
        <!-- <div class="carousel-item">
            <img class="d-block w-100" src="..." alt="Second slide">
        </div>
        <div class="carousel-item">
            <img class="d-block w-100" src="..." alt="Third slide">
        </div> -->
        </div>
    </div>
    <div id="banner" class="bg-5 container-fluid">app4food un pasto ed un incontro</h2>
	</div>


    <div id="app" class="container-fluid">
        <!--for testing -->
        <!--
        <div class="container">
            <button @click="loadDataTest">Simula caricamento dati</button>
            <h3> Da db</h3>
            <div v-for="l in layers" v-bind:key="l.id">
                <div v-for="riv in l.features" v-bind:key="riv.id">
                    {{riv.name}} {{riv.latitude}}, {{riv.longitude}}, {{riv.coords}}, {{riv.type}}<br>
                </div>
            </div>

        </div>
        -->
        
            <!-- the function buttons layer here-->
            <div class="container-fluid text-center">
                <a class="btn btn-info btn-lg btn-block" href="./form.html" role="button">inserisci</a>

                <!-- <div id="buttons" class="btn-group " role="group" aria-label="Basic example">  -->
               <!-- <a class="btn btn-success" href="./index.html" role="button">Cerca</a> -->
               <!-- <a class="btn btn-info disabled" href="./map.html" role="button"> mappa</a> -->
                <!-- <a class="btn btn-info" href="./map.html" role="button"> mappa</a>  -->
                <!-- <a class="btn btn-info " href="./search.html" role="button"> cerca</a> -->
                <!-- <a class="btn btn-secondary " href="./form.html" role="button">inserisci</a> -->
                <!-- <a class="btn btn-info disabled" href="./modify.html" role="button" >modifica</a> -->
                <!-- <a class="btn btn-info disabled" href="./delete.html" role="button">cancella</a> -->
               <!-- <a class="btn btn-info" href="./crea.html" role="button">info</a> --> 
               <!-- </div> -->
           </div>
                <!-- <a class="btn btn-info" href="./crea.html" role="button">info</a> --> 
        
            <!-- The layer checkboxes go here -->
            <div class="form-check"  v-for="layer in layers" :key="layer.id">
            <!-- <div class="form-check " v-for="layer in layers" :key="layer.id"> -->
                <!-- label and input elements go here -->
                <!-- <label class="form-check-label" for="flexSwitchCheckDefault"></label> -->
                <label class="form-check-label">
                <input class="form-check-input" type="checkbox" v-model="layer.active"
                        @change="layerChanged(layer.id, layer.active)" />
                {{ layer.name }}</label>
            </div>     
            <div id="map" class="map">
            </div> 
        </div>

    <script>
        const staticData = {
                        "records": [
                            {
                            "id": "1",
                            "name": "pippo",
                            "note": "Ha bisogno di coperte ed è diabetico.",
                            "latitude": "44.4975",
                            "longitude": "11.3419",
                            "type": "marker",
                            "created": "2021-04-11 12:39:39",
                            "modified": "2021-04-15 14:27:45",
                            "coords": [
                                44.4975,
                                11.3419
                            ]
                            },
                            {
                            "id": "2",
                            "name": "non conosciuto",
                            "note": "Si sta aprendo ed inizia a parlare",
                            "latitude": "44.4966",
                            "longitude": "11.3408",
                            "type": "marker",
                            "created": "2021-04-11 12:43:36",
                            "modified": "2021-04-15 14:27:45",
                            "coords": [
                                44.4966,
                                11.3408
                            ]
                            },
                            {
                            "id": "3",
                            "name": "Nico",
                            "note": "Parla male l'italiano, ha voglia di parlare",
                            "latitude": "44.4965",
                            "longitude": "11.3424",
                            "type": "marker",
                            "created": "2021-04-11 12:43:36",
                            "modified": "2021-04-15 14:27:45",
                            "coords": [
                                44.4965,
                                11.3424
                            ]
                            }
                        ]
                        };

        vm = new Vue({
            el: '#app',
            data: {
                /* Data properties will go here */
                filtra: '',
                status: [],
                //features:[],
                map: null,
                tileLayer: null,
                layers: [
                    {
                        id: 0,
                        name: 'Senza fissa dimora',
                        active: true,
                        features: [],
                    },
                    {
                        id: 1,
                        name: 'Zone di Bologna',
                        active: false,
                        features: [
                            {
                                id: 0,
                                name: 'zona 1 piazza dei martiri via galliera via Parigi',
                                type: 'polygon',
                                coords: [
                                    [44.50250,11.33973],
                                    [44.50133,11.34350],
                                    [44.49632,11.34292],
                                    [44.49716,11.33857],
                                    [44.50250,11.33973],
                                ],
                            }, {
                                id: 1,
                                name: 'zona 2 piazza maggiore via rizzoli via indipendenza',
                                type: 'polygon',
                                coords: [
                                    [44.49355,11.34235],
                                    [44.49326,11.34359],
                                    [44.49446,11.34533],
                                    [44.49489,11.34279],
                                    [44.50446,11.34564],
                                    [44.50462,11.34540],
                                    [44.49492,11.34249],
                                    [44.49355,11.34235],
                                    
                                    
                                    
                                ],
                            },
                            {
                                id: 2,
                                name: 'zona 3 stazione fs via barozzi',
                                type: 'polygon',
                                coords: [
                                    [44.50485,11.34572],
                                    [44.50391,11.34926],
                                    [44.50615,11.35072],
                                    [44.50626,11.34615],
                                    [44.50485,11.34572],
                                ],
                            },
                            {
                                id: 3,
                                name: 'zona 4 porta castiglione piazza Cavour',
                                type: 'polygon',
                                coords: [
                                    [44.48522,11.34770],
                                    [44.49214,11.34483],
                                    [44.49201,11.34684],
                                    [44.48539,11.34877],
                                    [44.48522,11.34770],
                                ],
                            },
                            {
                                id: 4,
                                name: 'zona 5 porta saragozza meloncello',
                                type: 'polygon',
                                coords: [
                                    [44.4913,11.3305],
                                    [44.49024,11.31181],
                                    [44.48969,11.31145],
                                    [44.49014,11.33038],
                                    [44.4913,11.3305],
                                ],
                            },
                        ],
                    }],
            },
            mounted() {
                /* Code to run when app is mounted */
                //this.loadQuote();
                this.initMap();
                this.initLayers();
                //this.initLayers();

            },
            methods: {
                /* Any app-specific functions go here */
                initMap() {
                    this.map = L.map('map').setView([44.5001,11.3430], 15);
                    this.tileLayer = L.tileLayer(
                        //'https://cartodb-basemaps-{s}.global.ssl.fastly.net/rastertiles/voyager/{z}/{x}/{y}.png',
                        'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
                        {
                            maxZoom: 20,
                            attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>, &copy; <a href="https://carto.com/attribution">CARTO</a>',
                        }
                    );
                    this.tileLayer.addTo(this.map);
                },
                initLayers() {
                    this.layers.forEach((layer) => {
                        // Initialize the layer
                        const markerFeatures = layer.features.filter(feature => feature.type === 'marker');
                        const polygonFeatures = layer.features.filter(feature => feature.type === 'polygon');
                        markerFeatures.forEach((feature) => {
                            feature.leafletObject = L.marker(feature.coords)
                                .addTo(this.map)
                                .bindPopup(feature.name + '<br>' + feature.note +'<a href=./detail.html?id=' + feature.id + '> dettagli </a>');
                               // console.log(feature.id);
                        });
                        polygonFeatures.forEach((feature) => {
                            feature.leafletObject = L.polygon(feature.coords)
                                //.addTo(this.map)
                                .bindPopup(feature.name);
                        });
                    });
                },
                layerChanged(layerId, active) {
                    /* Show or hide the features in the layer */
                    const layer = this.layers.find(layer => layer.id === layerId);
                    layer.features.forEach((feature) => {
                        /* Show or hide the feature depending on the active argument */
                        if (active) {
                            
                            feature.leafletObject.addTo(this.map);
                        } else {
                            feature.leafletObject.removeFrom(this.map);
                        }
                    });
                },
                loadDataTest: function(){
                    setTimeout(()=>{
                        this.layers[0].features=staticData.records;
                        this.initLayers()}
                        ,1000);
                },
                loadQuote: function () {
                    //this.status = ;
                    axios.get('./api/homeless/search.php', {
                        params: { s: this.filtra }
                    }).then((res) => {
                        this.layers[0].features = res.data.records;
                        this.initLayers();
                    }).catch((res) => {
                        this.layers[0].features = 'Hompless non trovato';
                    })
                },
            },
            created() {
                //this.loadDataTest();
                this.loadQuote();
              

            },

        });
      /* var  vm = new Vue({
              el: '#app',
              data: {
                  status:[],
                  filtra: 'Italia',
                  currentSort:'regione',
                  currentSortDir:'asc'
              },
              methods: {
                  loadQuote: function() {
                      //this.status = ;
                      axios.get('http://127.0.0.1/geomagazine/api/magazine/search.php' , {params: {s:this.filtra}
                          }).then((res) => {
                              this.status = res.data.records;
                          }).catch((res) => {
                              this.status = 'Magazine non trovato';
                          })
                  },
                  sort:function(s) {
                      //if s == current sort, reverse
                      if(s === this.currentSort) {
                      this.currentSortDir = this.currentSortDir==='asc'?'desc':'asc';
                      }
                      this.currentSort = s;
                  }
              },
  
              computed:{
                  sortedList:function() {
                      return this.status.sort((a,b) => {
                      let modifier = 1;
                      if(this.currentSortDir === 'desc') modifier = -1;
                      if(a[this.currentSort] < b[this.currentSort]) return -1 * modifier;
                      if(a[this.currentSort] > b[this.currentSort]) return 1 * modifier;
                      return 0;
                      });
                  }
                  },
              created: function(){
                  this.loadQuote()
                  this.sort()
              }
          }) */
    </script>
</body>

</html>

</body>

</html>